import Path from './Path';
var traverse = function (node, visitor, parentPath) {
    var _a, _b, _c, _d;
    // Create a path
    var path = new Path(node, parentPath);
    // Entering node
    (_b = (_a = visitor[path.node.type]) === null || _a === void 0 ? void 0 : _a.enter) === null || _b === void 0 ? void 0 : _b.call(_a, path);
    // Possible sub nodes
    switch (path.node.type) {
        case 'Array':
            path.node.elements.forEach(function (node) {
                traverse(node, visitor, path);
            });
            break;
        case 'Object':
            path.node.entries.forEach(function (node) {
                traverse(node, visitor, path);
            });
            break;
        case 'ObjectEntry':
            traverse(path.node.value, visitor, path);
    }
    // Exiting node
    (_d = (_c = visitor[path.node.type]) === null || _c === void 0 ? void 0 : _c.exit) === null || _d === void 0 ? void 0 : _d.call(_c, path);
    return path;
};
export default traverse;
