var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "never"], factory);
    }
})(function (require, exports) {
    "use strict";
    exports.__esModule = true;
    var never_1 = __importDefault(require("never"));
    var Path = /** @class */ (function () {
        function Path(node, parentPath) {
            this.node = node;
            this.parentPath = parentPath;
        }
        Path.prototype.removeChild = function (childNode) {
            switch (this.node.type) {
                case 'Array':
                    this.node.elements = this.node.elements.filter(function (node) { return node !== childNode; });
                    break;
                case 'Object':
                    this.node.entries = this.node.entries.filter(function (node) { return node !== childNode; });
                    break;
                default:
                    throw new Error("Cannot remove child from node type: " + this.node.type);
            }
        };
        Path.prototype.remove = function () {
            var _a;
            ((_a = this.parentPath) !== null && _a !== void 0 ? _a : never_1["default"]('No parent path')).removeChild(this.node);
        };
        Path.prototype.replaceChild = function (currentChild, newChild) {
            switch (this.node.type) {
                case 'Array':
                    this.node.elements[this.node.elements.indexOf(currentChild)] = newChild;
                    break;
                case 'Object':
                    this.node.entries[this.node.entries.indexOf(currentChild)] = newChild;
                    break;
                case 'ObjectEntry':
                    this.node.value = newChild;
                    break;
                default:
                    throw new Error("Cannot remove child from node type: " + this.node.type);
            }
        };
        Path.prototype.replace = function (newNode) {
            var _a;
            (_a = this.parentPath) === null || _a === void 0 ? void 0 : _a.replaceChild(this.node, newNode);
            this.node = newNode;
        };
        return Path;
    }());
    exports["default"] = Path;
});
